## biosig 2.1.2

=== Makefile ===
####### Main Makefile for building the various biosig tools ####################
###
###  Copyright (C) 2010-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
################################################################################

exec_prefix ?= $(prefix)

first :: lib tools

java: lib
	make -C biosig4c++/java

python: lib
	make -C biosig4c++/python

lib:
	make -C biosig4c++ lib

tools: lib
	make -C biosig4c++ tools

mma mathematica: lib
	make -C biosig4c++/mma

mex4m matlab: lib
	make -C biosig4c++/mex mex4m

mex4o octave: lib
	make -C biosig4c++/mex mex4o

R: lib
	make -C biosig4c++/R

install ::
	make -C biosig4c++ install
	install -d $(DESTDIR)/usr/local/share/biosig/matlab
	cp -r biosig4matlab/* $(DESTDIR)/usr/local/share/biosig/matlab/
	-rm -rf $(DESTDIR)/usr/local/share/biosig/matlab/maybe-missing

uninstall ::
	make -C biosig4c++ uninstall
	-rm -rf $(DESTDIR)/usr/local/share/biosig

clean ::
	make -C biosig4c++/mma clean
	make -C biosig4c++ clean

distclean : clean
        # also configure.ac for list of files
	rm Makefile biosig4c++/Makefile biosig4c++/*/Makefile \
		biosig4c++/python/setup.py \
		biosig4c++/R/DESCRIPTION

ifneq (:,/usr/bin/java)
ifneq (:,/usr/bin/javac)
first :: lib
	-make -C biosig4c++/java
endif
clean ::
	-make -C biosig4c++/java clean
test ::
	-make -C biosig4c++/java test
endif

ifneq (:,/usr/local/bin/mathematica)
first :: lib
	make -C biosig4c++/mma
install ::
	-make -C biosig4c++/mma install
uninstall ::
	-make -C biosig4c++/mma uninstall
endif

ifneq (:,:)
MATLAB_MEX := $(shell dirname :)/mex
first ::
	make -C biosig4c++/mex mex4m
install ::
	make -C biosig4c++/mex install
uninstall ::
	make -C biosig4c++/mex uninstall
endif

ifneq (:,/usr/bin/octave)
ifneq (:,/usr/bin/mkoctfile)
BIOSIG_MEX_DIR = $(DESTDIR)$(shell octave-config -p LOCALOCTFILEDIR)/biosig
BIOSIG_DIR     = $(DESTDIR)$(shell octave-config -p LOCALFCNFILEDIR)/biosig
first ::
	make octave
	make -C biosig4c++ mexbiosig
install ::
	# mexbiosig
	#-/usr/bin/octave --no-gui --eval "pkg install -global biosig4c++/mex/mexbiosig-2.1.2.src.tar.gz"
	# *.mex
	install -d $(BIOSIG_MEX_DIR)
	install biosig4c++/mex/*.mex $(BIOSIG_MEX_DIR)
	# biosig for octave and matlab
	install -d $(BIOSIG_DIR)
	cp -r biosig4matlab/*  $(BIOSIG_DIR)
	-rm -rf $(BIOSIG_DIR)/maybe-missing

uninstall ::
	# mexbiosig
	#-/usr/bin/octave --no-gui --eval "pkg uninstall -global mexbiosig"
	# *.mex
	-rm -rf $(BIOSIG_MEX_DIR)
	# biosig for octave and matlab
	-rm -rf $(BIOSIG_DIR)
endif
endif

ifneq (:,/usr/bin/python3)
first biosig4c++/python/dist/Biosig-2.1.2.tar.gz ::
	-PYTHON=/usr/bin/python3 make -C biosig4c++/python dist/Biosig-2.1.2.tar.gz
install :: biosig4c++/python/dist/Biosig-2.1.2.tar.gz
	-/usr/bin/python3 -m pip install $<
	-$(foreach py, $(shell pyversions -i),  $(py) -m pip install $<;)
	-$(foreach py, $(shell py3versions -i), $(py) -m pip install $<;)
uninstall ::
	-/usr/bin/python3 -m pip uninstall -y $<
	-$(foreach py, $(shell pyversions -i),  $(py) -m pip uninstall -y Biosig;)
	-$(foreach py, $(shell py3versions -i), $(py) -m pip uninstall -y Biosig;)
clean ::
	make -C biosig4c++/python clean
endif

ifneq (:,/usr/bin/R)
first ::
	-make -C biosig4c++/R build
install ::
	-make -C biosig4c++/R install
clean ::
	-make -C biosig4c++/R clean
endif

all: first #win32 win64 #sigviewer #win32/sigviewer.exe win64/sigviewer.exe #biosig_client biosig_server mma java tcl perl php ruby #sigviewer

#---- automatic remaking ---------------------------------------------------#
#   https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/Automatic-Remaking.html#Automatic-Remaking
#---------------------------------------------------------------------------#
$(srcdir)/configure: configure.ac aclocal.m4
	autoconf

# autoheader might not change config.h.in, so touch a stamp file.
$(srcdir)/config.h.in: stamp-h.in
$(srcdir)/stamp-h.in: configure.ac aclocal.m4
	autoheader
	echo timestamp > '$(srcdir)/stamp-h.in'

config.h: stamp-h
stamp-h: config.h.in config.status
	./config.status

Makefile: Makefile.in config.status
	./config.status

config.status: configure
	./config.status --recheck

=== biosig4c++/DESCRIPTION ===
Name: BioSig
Version: 2.1.2
Date: 2021-01-06
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: BioSig
Description: A software library for biomedical signal processing.
Depends: octave (> 2.9.0),
License: GPL version 3 or later
Url: http://biosig.sf.net

=== biosig4c++/Makefile ===
######## Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2020 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at https://biosig.sourceforge.io/
###
##############################################################

##### Target: GNU/Linux
#
## make && make install    build and install libbiosig, but no other tools.
#             libbiosig is a prerequisite for building all the other tools below.
#
## make save2gdf   - makes converter
## make biosig_fhir   - makes converter for fhir-binary template
## make install_save2gdf   - installs converter
## make install_mma 	installs biosig's sload for Mathematica in $PREFIX/share/biosig/mathematica
## make install_mex 	installs mexbiosig for Matlab in $PREFIX/share/biosig/mex
#
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o, mex4m, mexw32, mexw64 combined
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
##
## make win32 and make win64 are obsolete. save2gdf.exe, and libbiosig.{a,dll} for windows can now be built
## with the mingw-cross-compiler environment (mxe.cc).
##    git clone https://github.com/schloegl/mxe.git
##    make biosig
## should do what you want. Please note, that win32mma does now also rely that libbiosig is built with MXE.
## Make sure that CROSS or CROSS64 is properly defined when running `make`
##
## ???
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt

##### Target: MacOSX w/ homebrew
## make install_homebrew	installs libbiosig and save2gdf
	# requires: brew tap homebrew/dupes
	#	    brew install libiconv

#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
ifeq (,$(findstring mingw,$(TARGET)))
    -include /usr/share/dpkg/buildflags.mk
endif

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################

### User-specified options: its likely you want to change this
# settings for cross compiler: tested with MXE and mce-w64 with make suitesparse zlib qt ;
CROSS   = $(HOME)/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
## local MXE
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS   = $(HOME)/src/mxe.master/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = $(shell pwd)/../mxe/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static
endif

CROSS64       = $(HOME)/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif

# settings for mex files
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
# directory for sources of sigviewer
PathToSigViewer = ../sigviewer
PathToSigViewerWIN32 = ../sigviewer4win32
PathToSigViewerWIN64 = ../sigviewer4win64

CFLAGS       += -pipe -fPIC -fno-builtin-memcmp -O2 -Wno-unused-result
CFLAGS       += -Wno-deprecated
CFLAGS       += -fvisibility=hidden

prefix        = /usr/local
exec_prefix  ?= /usr/local
libdir        = ${exec_prefix}/lib
includedir    = ${prefix}/include
bindir        = ${exec_prefix}/bin
mandir        = ${prefix}/share/man

CFLAGS       += -I$(includedir)
CXXFLAGS     += $(CFLAGS)

## TARGET dependencies
ifeq (,$(TARGET))
	CC      ?= gcc
	CXX     ?= g++
	AR      := ar rcs
	PKGCONF := pkg-config
	SHAREDLIB = -shared
	DLEXT    = so
else ifeq (intel,$(TARGET))
	CC      := icc
	CXX     := icc
	LD      := xild
	AR      := xiar crs
else
	PREFIX  := $(subst /bin/,/,$(dir $(shell which $(TARGET)-gcc)))
	CC      := $(TARGET)-gcc
	CXX     := $(TARGET)-g++
	LD      := $(TARGET)-ld
	AR      := $(TARGET)-ar rcs
	PKGCONF := $(TARGET)-pkg-config
	ifneq (,$(findstring mingw,$(TARGET)))
		## add gnulib's getlogin
		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
		OBJECTS += getlogin.o getline.o getdelim.o
		LDLIBS  += -lssp
		LDLIBS  += -liconv -lstdc++ -lws2_32
		PKG_CONFIG_LIBS += -liconv -lws2_32
		BINEXT   = .exe
		DLEXT    = dll
	endif
endif

SONAMEVERSION ?= 3

### TODO: DLEXT does not work correctly on MXE/MINGW
ifneq (,$(findstring Darwin, $(shell uname)))
	## Homebrew:
	##	brew install gawk
	##	brew install gnu-tar
	##	brew install homebrew/dupes/libiconv
	##	brew install homebrew/science/suite-sparse
	##
	TAR	       = gtar
	LD	       = $(CXX) -shared
	CFLAGS        += -I$(prefix)/include
	CFLAGS        += -mmacosx-version-min=10.13
	LDLIBS        += -liconv -lstdc++
	SHAREDLIB      = -dylib -arch x86_64 #-macosx_version_min 10.13
	LDFLAGS       += -L$(prefix)/lib/
	DLEXT          = dylib
	FULLDLEXT      = .dylib
	SONAME_PREFIX  = -install_name # the last space character is crucial

else ifneq (,$(findstring CYGWIN, $(shell uname)))
	### TODO: check if this path is useful at all ###
	DLEXT = dll
	TAR	       = tar
	LD	       = $(CXX)
	LDLIBS        += -liconv -lstdc++
	FULLDLEXT      = ${SONAMEVERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=

else ifneq (,$(findstring MINGW, $(shell uname)))
	### TODO: check if this path is useful at all ###
	## add gnulib's getlogin
	SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
	OBJECTS += getlogin.o getline.o getdelim.o
	## exclude conflicting definition of sopen from mingw's io.h
	CC  = gcc
	CXX = g++
	CFLAGS  += -pipe -fPIC -D_REENTRANT -D=BUILD_DLL
	TAR	 = tar
	LD	 = $(CXX)
	FULLDLEXT      = ${SONAMEVERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=
	LDLIBS  += -lstdc++
	LDLIBS  += -liconv -lws2_32
	LDFLAGS += -Wl,-subsystem,windows
	LDFLAGS += -L$(prefix)/lib/

else
	TAR	       = tar
	LD	       = $(CXX)
	FULLDLEXT      = .so.${SONAMEVERSION}
	SONAME_PREFIX  = -Wl,-soname=
endif

DEFINES_ALL   = #-D=NDEBUG

DEFINES      += $(DEFINES_ALL)
#DEFINES      += -D=WITH_SON
#DEFINES      += -D=WITHOUT_SCP_DECODE
#DEFINES      += -D=WITH_TIMESTAMPEVENT
#DEFINES      += -D=WITH_TIMESTAMPCHANNEL
### Mingw,MXE, etc. must avoid name space conflict concerning SOPEN ###
#DEFINES      += -D=NO_OLDNAMES

#DEFINES      += -D=WITH_CURL
DEFINES      += -D=__4HAERTEL__
DEFINES      += -D=WITH_FAMOS
DEFINES      += -D=WITH_FIFF
DEFINES      += -D=WITHOUT_NETWORK
DEFINES      += -D=WITH_SCP3
DEFINES      += -D=WITH_FEF
#DEFINES      += -D=WITH_PDP
	### DICOM: DCMTK or GDCM, or internal
	# WITH_DCMTK is already configured by autoconf
	# WITH_GDCM is experimental
	# WITH_DICOM (internal implementation) is experimental
#DEFINES      += -D=WITH_GDCM
#DEFINES      += -D=WITH_GSL
#DEFINES      += -D=WITH_EEPROBE
DEFINES      += -D=WITH_INTAN
#DEFINES      += -D=WITH_TDMS
DEFINES      += -D=WITH_ATF
#DEFINES      += -D=WITH_AVI
#DEFINES      += -D=WITH_RIFF
#DEFINES      += -D=WITH_WAV
#DEFINES      += -D=WITH_NEV
DEFINES      += -D=MAKE_EDFLIB

ifeq (1,1)
	LDLIBS     += -lz
endif
ifeq (1,@HAVE_LIBPTHREAD@)
	LDLIBS     += -lpthread
endif
ifeq (1,1)
	LDLIBS     += -lcholmod
	ifeq (Darwin,$(shell uname))
	  ## homebrew requires this in addition to cholmod
	  LDLIBS     += -lsuitesparseconfig
	endif
endif
ifeq (1,1)
	DEFINES      += -D=WITH_DCMTK
	LDLIBS       += -ldcmdata -loflog -lofstd
	SOURCES      += t210/sopen_dcmtk_read.cpp
	OBJECTS      += sopen_dcmtk_read.o
	MinGWOBJECTS += win32/sopen_dcmtk_read.obj
endif
ifeq (1,@HAVE_LIBHDF5@)
	LDLIBS     += -lhdf5
endif
ifeq (1,@HAVE_LIBMATIO@)
	LDLIBS     += -lmatio
endif
ifeq (1,1)
	LDLIBS     += -lm
endif
ifeq (1,1)
	DEFINES    += -D=WITH_LIBTINYXML
	LDLIBS     += -ltinyxml
endif
ifeq (1,@HAVE_LIBTINYXML2@)
	DEFINES    += -D=WITH_LIBTINYXML2
	LDLIBS     += -ltinyxml2
endif

ifneq (,$(findstring WITH_GDCM, $(DEFINES)))
  INCPATH    += -I$(wildcard /usr/include/gdcm-2*/)
  LDLIBS     += -lgdcmCommon -lgdcmDSED -lgdcmMEXD -lgdcmMSFF -lgdcmDICT -lgdcmIOD
endif

ifneq (,$(findstring WITH_CURL, $(DEFINES)))
  LDLIBS     += -lcurl
endif
ifneq (,$(findstring stack-protector, $(CFLAGS)))
ifneq (,$(findstring CYGWIN, $(shell uname)))
  LDLIBS     += -lssp
endif
ifneq (,$(findstring MINGW, $(shell uname)))
  LDLIBS     += -lssp
endif
endif

DELETE        = rm -f
COPY          = cp -f
DATA_DIR      = data/
DATA_DIR_CFS  = $(HOME)/L/data/test/cfs/
TEMP_DIR      = test/
SED           = sed
VERBOSE	     := -V0

##########################################################
## set Matlab and Octave variables
ifeq (undefined,$(origin MATLABDIR))
  ifeq (Darwin,$(shell uname))
    MATLABDIR := $(shell find /Applications/MATLAB* -name bin -type d -depth 1 2>/dev/null | head -1)
  else
    MATLABDIR ?= $(shell find /usr/local/MATLAB* -maxdepth 2 -name bin -type d 2>/dev/null | head -1)
  endif
endif

ifeq (,$(MATLABDIR))
  #$(warning MATLABDIR is not defined)
else
  MEX         = $(MATLABDIR)/mex
  MEX_EXT    := $(shell $(MATLABDIR)/mexext)
endif


# use environment variable to define OCTAVE_VERSION
#   e.g. export OCTAVE_VERSION=-3.6.2
# Octave - global install  (e.g. from debian package)
#OCTAVE_VERSION =
# Octave - local install (e.g. compiled from sources)
#OCTAVE_VERSION = -3.6.1

OCT           := mkoctfile$(OCTAVE_VERSION)
##########################################################

##########################################################
## set variables for MinGW Crosscompiler: compile on linux binaries for windows
##
PathToMinGW   = $(dir $(CROSS))..$(nondir $(CROSS))
PathToMinGW64 = $(dir $(CROSS64))..$(nondir $(CROSS64))

MinGWCC      = $(CROSS)-gcc
MinGWCXX     = $(CROSS)-g++
MinGWDEF     = $(DEFINES)
MinGWCFLAGS  = -pipe -fPIC  -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin32 -I$(PathToMinGW)/include/
MinGWLIBS    = win32/libbiosig.a -L$(PathToMinGW)/lib/ $(LDLIBS) # static
MinGWLINK    = $(MinGWCXX)

MinGW64CC      = $(CROSS64)-gcc
MinGW64CXX     = $(CROSS64)-g++
MinGW64CFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin64 -I$(PathToMinGW64)/include/
MinGW64LIBS    = win64/libbiosig.a -L$(PathToMinGW64)/lib/ $(LDLIBS) # static
MinGW64LINK    = $(MinGW64CXX)
##########################################################

# Versioning
MAJOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig-dev.h))
MINOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig-dev.h))
STEPPING       := $(word 3, $(shell grep '\#define BIOSIG_PATCHLEVEL' biosig-dev.h))
BIOSIG_VERSION := 2.1.2
TODAY          := $(shell date +%Y%m%d)

####### Output directory
OBJ	      = ./obj

####### Files
SOURCES      += biosig.c \
		biosig2.c \
		t210/sopen_cfs_read.c \
		t210/sopen_heka_read.c \
		t210/sopen_igor.c \
		t210/sopen_rhd2000_read.c \

=== biosig4c++/R/DESCRIPTION ===
Package: biosig
Version: 2.1.2
Date: 2020-08-22
Encoding: UTF-8
Title: Biomedical Signal Tools
Authors@R: person("Alois", "Schlögl", role = c("aut", "cre"),
                     email = "alois.schloegl@gmail.com", comment="https://orcid.org/0000-0002-5621-8100")
Author: Alois Schlögl [aut, cre]
Maintainer: Alois Schlögl <alois.schloegl@gmail.com>
Depends: R (>= 3.1.0)
Suggests: 
Description: Import filter for about 50 different biomedical signals data formats.
License: GPL (>= 3)
URL: https://biosig.sourceforge.io, http://pub.ist.ac.at/~schloegl
BugReports: https://sourceforge.net/projects/biosig/support

=== biosig4c++/R/Makefile ===

BIOSIG4R_PKG = biosig_2.1.2.tar.gz

build: $(BIOSIG4R_PKG)

sload.so: sload.c
	R CMD SHLIB sload.c -I.. -L.. -lbiosig

clean:
	rm *.o *.so *.gz $(BIOSIG4R_PKG)

$(BIOSIG4R_PKG):
	R CMD build .
	R CMD check --as-cran $@

install: $(BIOSIG4R_PKG)
	R CMD INSTALL $<

=== biosig4c++/mex/DESCRIPTION ===
Name: mexbiosig
Version: 1.7.2
Date: 2015-08-31
Author: Alois Schloegl <alois.schloegl@ist.ac.at>
Maintainer: Alois Schloegl
Title: The mexBiosig toolbox
Description: Accessing Biosig files through libbiosig's mex-files
Depends: octave (> 3.2.0)
SystemRequirements: libbiosig (> 1.3.0)
License: GPLv3+
Url: http://pub.ist.ac.at/~schloegl/matlab/biosig
Autoload: yes

=== biosig4c++/mex/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2020 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

##### Target: GNU/Linux
#
## make && make install    build and install libbiosig, but no other tools.
#             libbiosig is a prerequisite for building all the other tools below.
#
## make save2gdf   - makes converter
## make install_save2gdf   - installs converter
#
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o, mex4m, mexw32, mexw64 combined
## make biosig4python - makes python interface (requires Python)
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
##
## make win32 and make win64 are obsolete. save2gdf.exe, and libbiosig.{a,dll} for windows can now be built
## with the mingw-cross-compiler environment (mxe.cc).
##    git clone https://github.com/schloegl/mxe.git
##    make biosig
## should do what you want. Please note, that win32mma does now also rely that libbiosig is built with MXE.
## Make sure that CROSS or CROSS64 is properly defined when running `make`
##
## ???
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt 

##### Target: MacOSX w/ homebrew
## make install_homebrew	installs libbiosig and save2gdf
	# requires: brew tap homebrew/dupes
	#	    brew install libiconv

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################


## TARGET dependencies
ifeq (,$(TARGET))
	CC      ?= gcc
	CXX     ?= g++
	AR      := ar rcs
	PKGCONF := pkg-config
ifneq (Darwin,$(shell uname))
	LFLAGS  += -Wl,-z,relro,-z,now
endif
else ifeq (intel,$(TARGET))
	CC      := /opt/intel/bin/icc
	CXX     := /opt/intel/bin/icc
	LD      := /opt/intel/bin/xild
	AR      := /opt/intel/bin/xiar crs
else 
	prefix  := $(dir $(shell which $(TARGET)-gcc))
	CC      := $(TARGET)-gcc
	CXX     := $(TARGET)-g++
	LD      := $(TARGET)-ld
	AR      := $(TARGET)-ar rcs
	PKGCONF := $(TARGET)-pkg-config
	ifeq (mingw, $(findstring mingw, $(TARGET)))
		## add gnulib's getlogin
		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
		OBJECTS += getlogin.o getline.o getdelim.o
		## exclude conflicting definition of sopen from mingw's io.h
		CFLAGS  += -I.
		IO_H_FILE2 = io.h
		CFLAGS  += -I$(prefix)/include
		LIBS    += -lssp
		LDLIBS  += -liconv -lws2_32
	endif
endif

ifeq (Darwin,$(shell uname))
	## Homebrew:
	##	brew tap homebrew/dupes
	##	brew install libiconv
	##
	LD	       = ld
	CFLAGS        += -I/usr/local/opt/libiconv/include
	LDLIBS        += -L/usr/local/opt/libiconv/lib/ -liconv -lstdc++
	LDFLAGS        += -dylib -arch x86_64 -macosx_version_min 10.9
	DLEXT          = dylib
	FULLDLEXT      = ${BIOSIG_VERSION}.dylib
	SONAME_PREFIX  = -install_name # the last space character is crucial
	SONAME_POSTFIX = .${MAJOR_VERSION}.${MINOR_VERSION}.$(DLEXT)
else
	LD	       = $(CXX)
	LDFLAGS       += -shared
	DLEXT          = so
	FULLDLEXT      = so.${BIOSIG_VERSION}
	SONAME_PREFIX  = -Wl,-soname=
	SONAME_POSTFIX = .$(DLEXT).${MAJOR_VERSION}.${MINOR_VERSION}
endif

exec_prefix ?= /usr/local

DEFINES_ALL   = #-D=NDEBUG

LIBS         += $(LDLIBS)

DELETE        = rm -f
COPY          = cp -f
DATA_DIR      = data/
DATA_DIR_CFS  = $(HOME)/L/data/test/CFS/
TEMP_DIR      = test/
VERBOSE	     := -V0

##########################################################
## set Matlab and Octave variables
MATLABDIR ?= $(shell dirname :)

ifeq (.,$(MATLABDIR))
  #$(warning MATLABDIR is not defined)
else
  MEX         = $(MATLABDIR)/mex
  MEX_EXT    := $(shell $(MATLABDIR)/mexext)
endif


# use environment variable to define OCTAVE_VERSION
#   e.g. export OCTAVE_VERSION=-3.6.2
# Octave - global install  (e.g. from debian package)
#OCTAVE_VERSION = 
# Octave - local install (e.g. compiled from sources) 
#OCTAVE_VERSION = -3.6.1

OCT           := mkoctfile$(OCTAVE_VERSION)
##########################################################

first: mex4o 

### Install mexbiosig for Matlab and Octave
install:
	mkdir -p $(DESTDIR)$(exec_prefix)/libexec/biosig/matlab
	install *.mex*   $(DESTDIR)$(exec_prefix)/libexec/biosig/matlab
	@echo "  mexBiosig for Matlab is installed in $(exec_prefix)/libexec/biosig/matlab";
	@echo "  Usage: Start Matlab and addpath ";
	@echo " addpath('$(exec_prefix)/libexec/biosig/matlab')";
	@echo " mexSLOAD";

uninstall:
	# from older source installations
	-${RM} $(DESTDIR)${prefix}/share/biosig/mex/*
	-cd $(DESTDIR)${prefix}/share && rmdir -p biosig
	# from later than 2.0.6 installations
	-${RM} $(DESTDIR)$(exec_prefix)/libexec/biosig/matlab/{mexSLOAD,mexSOPEN,mexSSAVE,physicalunits}.mex*
	-cd $(DESTDIR)$(exec_prefix)/libexec && rmdir -p biosig/matlab

#############################################################
#	Compilation: Implicit, default rules
#############################################################


#############################################################
#	MEX-files for Octave and Matlab
#############################################################

# include directory for Win32-Matlab include
W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/ -I../win32
W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/ -I../win64
# path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
GNUMEX   = $(HOME)/bin/win32/gnumex
GNUMEX64 = $(HOME)/bin/win64/gnumex

mexSOPEN.cpp : mexSLOAD.cpp
	echo "#define mexSOPEN" > mexSOPEN.cpp
	cat mexSLOAD.cpp >> mexSOPEN.cpp

MEX_OBJECTS = mexSLOAD.cpp mexSOPEN.cpp mexSSAVE.cpp physicalunits.cpp

mex4o:  $(patsubst %.cpp, %.mex, $(MEX_OBJECTS))
oct:    $(patsubst %.cpp, %.oct, $(MEX_OBJECTS))
mexw32: $(patsubst %.cpp, %.mexw32, $(MEX_OBJECTS))
mexw64: $(patsubst %.cpp, %.mexw64, $(MEX_OBJECTS))

ifdef MEX_EXT
mex: mex4o mex4m mexw32 mexw64
mex4m: $(patsubst %.cpp, %.$(MEX_EXT), $(MEX_OBJECTS))

%.$(MEX_EXT): %.cpp
	$(MEX) $(MEX_OPTION) $(DEFINES) -I.. "$<" -L.. -lbiosig -output "$@"

else
mex: mex4o mexw32 mexw64
endif

%.mex: %.cpp
	$(OCT) $(DEFINES) -I.. -v -g --mex "$<" -L.. -lbiosig -o "$@"

%.oct: %.cpp
	$(OCT) $(DEFINES) -I.. "$<" -L.. -lbiosig -o "$@"

%.mexw32: %.cpp
	## $(CROSS)-g++ is used instead of $(CXX), so it can be called from biosig as well as mxe. 
	$(CROSS)-g++ -shared $(GNUMEX)/mex.def -DMATLAB_MEX_FILE $(DEFINES) -x c++ \
		-I$(prefix)/include \
		-I$(W32MAT_INC) -O2 -o "$@" -L$(GNUMEX) -s "$<" -llibmx -llibmex $(shell $(CROSS)-pkg-config --libs libbiosig)

%.mexw64: %.cpp
	$(CROSS64)-g++ -shared $(GNUMEX64)/mex.def -DMATLAB_MEX_FILE $(DEFINES) -x c++ \
		-I$(prefix)/include \
		-I$(W64MAT_INC) -O2 -o "$@" -L$(GNUMEX64) -s "$<" -llibmx -llibmex $(shell $(CROSS64)-pkg-config --libs libbiosig)

clean:
	-$(DELETE) *.o *.obj *.o64 core octave-core *.oct *.mex* mexSOPEN.cpp

=== biosig4c++/mma/Makefile ===
####### Makefile to compile biosig.exe for loading data supported by libbiosig into Mathematica
###
###  Copyright (C) 2010-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


###########################################
# user-defined variables
###########################################
CROSS   ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
CROSS64 ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static

exec_prefix ?= /usr/local

###########################################
## set Mathematica variables
MATHEMATICA_EXE = /usr/local/bin/mathematica
MATHEMATICA_EXE ?= $(shell which mathematica)
ifeq (,$(MATHEMATICA_EXE))
        $(error "mathematica not found in $$PATH - cannot compile biosig for Mathematica")
endif
MLINKDIR ?= $(shell dirname $(shell dirname $(shell readlink -f $(MATHEMATICA_EXE) ) ) )

ifneq (,$(findstring Darwin,$(shell uname)))
MLINKDIR := /Applications/Mathematica.app/Contents/
SYS       = MacOSX-x86-64
LDFLAGS  += -demangle -dynamic -arch x86_64
LDFLAGS  += -framework CoreFoundation -framework CoreVideo -framework VideoDecodeAcceleration
else
SYS 	  = $(notdir $(shell ls -1d $(MLINKDIR)/SystemFiles/Links/MathLink/DeveloperKit/*))
ifneq (1,$(words ${SYS}))
SYS       = Linux-x86-64# Set this value with the result of evaluating $SystemID
endif
endif

# automated detection of most recent MLINTERFACE, without starting mathematica
# 10.0 supports 3 and 4, 9.0 and earlier supports only 3,
MLIVER := $(shell ${CC} mliver.c -I${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions/ -E -o - | tail -1)

#
# Windows
SYSwin       = Windows# Set this value with the result of evaluating $SystemID
MLLIBwin     = ml32i4m# Set this to ML64i3 if using a 64-bit system
SYSwin64     = Windows-x86-64# Set this value with the result of evaluating $SystemID
MLLIBwin64   = ml64i4# Set this to ML64i3 if using a 64-bit system
###########################################

CADDSDIR  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions
INCDIR    = -I${CADDSDIR} -I${MLINKDIR}/SystemFiles/IncludeFiles/C/
LIBDIR   += -L${CADDSDIR}

EXTRALIBS += -lm -ldl -luuid -lstdc++ # Set these with appropriate libs for your system.

ifeq (Darwin,$(shell uname))
MLLIB   = MLi${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
SED	= gsed
else
MLLIB   = ML$(shell getconf LONG_BIT)i${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
EXTRALIBS += -lrt
SED	= sed
endif
LD 	= ${CC}


ifneq (${MLIVER},)
CFLAGS += -DMLINTERFACE=${MLIVER}
endif

MPREP     = ${CADDSDIR}/mprep

TARGET    = biosig

# make Linux-x86-64
mma : $(patsubst %, ${SYS}/%.exe, $(TARGET))
# make Linux-x86-64, Windows, Windows-x86-64
all : $(patsubst %, ${SYS}/%.exe, $(TARGET)) $(patsubst %, ${SYSwin}/%.exe, $(TARGET)) $(patsubst %, ${SYSwin64}/%.exe, $(TARGET))

.c.o:
	${CC} ${CFLAGS} -I.. ${INCDIR} -c "$<"

%tm.c: %.tm
	${MPREP} "$<" -o "$@"
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#g' "$@"

${SYS}/%.exe: %.o %tm.o
	mkdir -p ${SYS}
	${LD} ${LDFLAGS} $? ${LIBDIR} -l${MLLIB} ${EXTRALIBS} -L.. -lbiosig  -o "$@"
	ln -sf "$@"


### Install Biosig for Mathematica
install : biosig.exe
	mkdir -p $(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica
	install biosig.exe	$(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica/
	@echo "  Biosig for Mathematica is installed in $(exec_prefix)/libexec/biosig/mathematica/biosig.exe";
	@echo "  Usage: Start Mathematica and run";
	@echo "\tlink=Install[\"$(exec_prefix)/libexec/biosig/mathematica/biosig.exe\"];";
	@echo "\t?Sload\n\t?Uload\n";

uninstall:
	${RM} $(DESTDIR)$(datadir)/biosig/mathematica/{sload,biosig}.exe
	-cd $(DESTDIR)$(datadir) && rmdir -p biosig/mathematica
	${RM} $(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica/biosig.exe
	-cd $(DESTDIR)$(exec_prefix)/libexec && rmdir -p biosig/mathematica

###########################################
#   Win32 - cross-compilation
###########################################

CCw32        = $(CROSS)-gcc
CADDSDIRwin  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin}/CompilerAdditions
INCDIRwin    = -I${CADDSDIRwin}
LIBDIRwin    = ${CADDSDIRwin}

EXTRALIBSwin = -lgdi32 -lm -lstdc++ -lws2_32 $(LDLIBS) # Set these with appropriate libs for your system.

MPREPwin     = ${CADDSDIRwin}/mprep.exe

%tm.win32.c : %.tm
	WINEPREFIX=${HOME}/.wine32.mma wine ${MPREPwin} "$<" -o "$@"
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#g' "$@"

${SYSwin}/%.obj : %.c
	${CCw32} -o "$@" -c "$<" $(shell $(CROSS)-pkg-config --cflags libbiosig) ${INCDIRwin}

win32mma : $(patsubst %, ${SYSwin}/%.exe, $(TARGET))

#${SYSwin}/%.exe : ${SYSwin}/%.obj ${SYSwin}/%tm.obj		# uses MPREP
${SYSwin}/%.exe : ${SYSwin}/%.obj ${SYSwin}/%tm.win32.obj	# uses MPREPwin
	mkdir -p ${SYSwin}
	${CCw32} $? -mwindows -static-libgcc -static-libstdc++ $(shell $(CROSS)-pkg-config --libs libbiosig) -lssp -L${LIBDIRwin} -l${MLLIBwin} ${EXTRALIBSwin} -o "$@"


###########################################
#   Win64 - cross-compilation
###########################################

CCw64         = $(CROSS64)-gcc
CADDSDIRwin64 = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin64}/CompilerAdditions
INCDIRwin64   = -I${CADDSDIRwin64}
LIBDIRwin64   = ${CADDSDIRwin64}

#MPREPwin64    = ${CADDSDIRwin64}/mprep.exe

#%tm.win64.c : %.tm
#	WINEPREFIX=${HOME}/.wine64.mma wine64 ${MPREPwin64} "$<" -o "$@"
	#${MPREP} "$<" -o "$@"
#	${SED}  -i 's# __DATE__# ",__DATE__," ",__TIME__,"#' "$@"

${SYSwin64}/%.obj : %.c
	${CCw64} -o "$@" -c "$<" $(shell $(CROSS64)-pkg-config --cflags libbiosig) ${INCDIRwin64}

win64mma : $(patsubst %, ${SYSwin64}/%.exe, $(TARGET))

#${SYSwin64}/%.exe : ${SYSwin64}/%.obj ${SYSwin64}/%tm.win64.obj	# uses MPREPwin64
${SYSwin64}/%.exe : ${SYSwin64}/%.obj ${SYSwin64}/%tm.obj		# uses MPREP
	mkdir -p ${SYSwin64}
	${CCw64} $? -static-libgcc -static-libstdc++ $(shell $(CROSS64)-pkg-config --libs libbiosig) -lssp -L${LIBDIRwin64} -l${MLLIBwin64} ${EXTRALIBSwin} -o "$@"


###########################################
clean:
	-$(RM) *.o* */*.o*
	-$(RM) *tm.c */*tm.c
	-$(RM) *.exe */*.exe

=== biosig4c++/python/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2021 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository 
###  (biosig4c++) at http://biosig.sf.net/ 
###
##############################################################

PYTHON ?= python3
PYVER  := $(shell $(PYTHON) -c "import sys; print(sys.version[:3])")


release build target: dist/Biosig-2.1.2.tar.gz

# https://packaging.python.org/tutorials/packaging-projects/
dist/Biosig-2.1.2.tar.gz: setup.py biosigmodule.c
	$(PYTHON) setup.py sdist

install:
	-/usr/bin/python setup.py install
	-/usr/bin/python3 setup.py install

test:
	## get ../data/Newtest17-256.bdf
	make -C .. fetchdata
	## need to run from different directory, because
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print(biosig.header("data/Newtest17-256.bdf"))')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print(biosig.data("data/Newtest17-256.bdf"))')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) < python/demo2.py)

clean:
	-rm -rf build/*
	-rm -rf dist/*
	-rm *.so

wheel: setup.py biosigmodule.c
	-/usr/bin/python setup.py sdist bdist_wheel
	-/usr/bin/python3 setup.py sdist bdist_wheel

check: release
	twine check dist/*

=== biosig4c++/ruby/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2017 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-Ruby interface is available here
# http://www.swig.org/Doc1.3/Ruby.html


all:
	$(error support for biosig on ruby is not ready yet)
	swig -c++ -ruby biosig.i
	ruby extconf.rb
	make

clean:
	-rm *.cxx
	-rm *.o
	-rm *.pm
	-rm *.so

=== debian/changelog ===
biosig (2.1.2-4) unstable; urgency=medium

  * libbiosig: cherry pick some patches from upstream
    - fix EDF-to-GDF conversion for certain files
    - fix JSON export when SampleRate is undefined (e.g. Infinity)

 -- Alois Schlögl <alois.schloegl@gmail.com>  Thu, 15 Apr 2021 21:04:32 +0200

biosig (2.1.2-3) unstable; urgency=medium

  [ Alois Schlögl ]
  * octave-biosig:
  - bug fix: EDF+ event import (eeglab issue #93)
  - GDF files: support reading and writing of timezone information

 -- Alois Schlögl <alois.schloegl@gmail.com>  Tue, 26 Jan 2021 22:47:42 +0200

biosig (2.1.2-2) unstable; urgency=medium

  * Team upload.
  * debian/tests/control:
    - Rename command1 to octave-ext-prints-usage
    - Fix test failure with allow-stderr
    - Try to avoid octave's X11 warnings
  * Update merge request information in debian/patches
  * debian/watch: version=4

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sat, 16 Jan 2021 14:07:42 +0200

biosig (2.1.2-1) unstable; urgency=medium

  * Team upload.

  [ Alois Schlögl ]
  * update to upstream version 2.1.2
  * build biosig4python for all supported python versions
  * add biosig2gdf (which is required and useful for loadgdf{py,r})

  [ Juhani Numminen ]
  * debian/rules:
    - Replace explicit dh_numpy3 and dh_octave* by "dh --with"
    - Don't run the configure step twice and remove commented code
    - Build python packages by executing pybuild commands
    - Permissions fixing is now done by a patch
  * Create d/octave-biosig.install to replace installation code in d/rules
  * Create d/clean to replace cleaning code in d/rules
  * Document non-installed files in d/not-installed and let dh_missing fail if
    unknown files appear
  * New patches:
    - submake.patch: avoid "warning: jobserver unavailable"
    - cppflags_ldflags.patch: apply LDFLAGS and CPPFLAGS
    - delete_extra_dpkg_buildflags.patch: eliminate a potential source of
      packager confusion
    - disable_python_rule.patch: only use debian/rules to build python extension
    - clean_biosig2gdf.patch: add biosig2gdf executable to cleaned files
    - install_permissions.patch: give non-exec permissions to a *.pc file
    - install_strip.patch: do not strip debug symbols from the shared library
  * Use autopkgtest-pkg-python to check that the python module exists
  * Add superficial autopkgtest: octave --eval mexSLOAD
  * debian/control:
    - Add ${devlibs:Depends} to libbiosig-dev Depends
    - Fix typo in homepage
    - Standards-Version: 4.5.1
  * Trim trailing whitespace in debian/changelog

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Thu, 14 Jan 2021 17:09:54 +0200

biosig (2.1.0-1) unstable; urgency=medium

  * Adapt Vcs fields on Salsa to new source package name
  * Build-Depends: python3-setuptools
  * Closes: #972684, #973435
  * adapt config.status file

 -- Alois Schlögl <alois.schloegl@gmail.com>  Thu, 12 Nov 2020 23:17:41 +0200

biosig (2.0.6-1) unstable; urgency=medium

  [ Alois Schlögl ]
  * Fix Build-Depends
  * Fix Homepage
  * Fix watch file
  * add "Biosig for Octave and Matlab" and rename
    debian source package from "biosig4c++" to "biosig"
  * "Biosig for Octave and Matlab" is added to octave-biosig package
  * push SONAMEVERSION (provides libbiosig3 instead of libbiosig2)
  * fix configure for tinyxml
  * update to new upstream (v2.0.6,
    commit b605b38417630f4a5ee2fa7dcc886164041295da + some more changes)

  [ Andreas Tille ]
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Add Alois Schlögl to Uploaders
  * Fix installation of manpages
  * Reviewed debian/copyright

 -- Alois Schlögl <alois.schloegl@gmail.com>  Mon, 24 Aug 2020 01:07:41 +0200

biosig4c++ (1.9.5-2) UNRELEASED; urgency=medium

  * Build-Depends: python3-all-dev to cope with piuparts issue

 -- Andreas Tille <tille@debian.org>  Tue, 03 Mar 2020 09:07:32 +0100

biosig4c++ (1.9.5-1) unstable; urgency=medium

  [ Yaroslav Halchenko ]
  * Fresh upstream release
  * debian/patches
    - dropped patches/fix_soname.patch -- upstreamed
  * debian/control
    - added libtinyxml-dev to build-depends

  [ Andreas Tille ]
  * Take over package into Debian Med team maintenance
  * debian/gbp.conf: deleted since converted to default layout
  * Provide symbols file only for architectures where it can be used
    unchanged
  * Add Build-Depends: libdcmtk-dev, libxml2-dev, libb64-dev
    as upstream suggests
  * debhelper-compat 12
  * Standards-Version: 4.5.0
  * Secure URI in copyright format
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/changelog
  * Remove trailing whitespace in debian/rules
  * Use secure URI in debian/watch.
  * Remove empty debian/patches/series.
  * Set upstream metadata fields: Archive, Repository.
  * Drop Python2 support (some refinements for Python3 only
    Closes: #936207
  * Refresh symbols file
    Closes: #925643
  * Fix permissions
  * Drop unused lintian-overrides

 -- Andreas Tille <tille@debian.org>  Mon, 02 Mar 2020 08:32:47 +0100

biosig4c++ (1.9.3-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
    Closes: #860081
  * debian/gbp.conf:
     - debian-branch is now debian
     - cleanup from old syntax specifying default settings
  * debhelper 9
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * debian/blends: removed since redundant (debian/upstream/metadata)
  * Drop -dbg package in favour of autogenerated one
  * Add python3-biosig
  * Delete outdated README.Debian
  * Drop paragraph about source tarball generated from git from README.source
  * Adapt lintian-overrides
  * Use d-shlibs
  * Several symbols from version 1.3.6 are missing thus there is an ABI change
    and SOVERSION needs to be bumped
    --> set SOVERSION=2
  * Re-activate and update symbols file

  [ Rafael Laboissiere ]
  * d/control: Build-depends on dh-octave


=== debian/control ===
Source: biosig
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Alois Schlögl <alois.schloegl@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               d-shlibs,
               gawk,
               python3-setuptools,
               python3-all-dev,
               python3-numpy,
               zlib1g-dev,
               libsuitesparse-dev,
               dh-octave,
               libdcmtk-dev,
               libtinyxml-dev,
               libb64-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/biosig
Vcs-Git: https://salsa.debian.org/med-team/biosig.git
Homepage: https://biosig.sourceforge.io/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python

Package: libbiosig3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - dynamic library
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides dynamic library.

Package: libbiosig-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libbiosig3 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - development files
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides header files and static library.

Package: biosig-tools
Architecture: any
Depends: libbiosig3 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: format conversion tools for biomedical data formats
 Based on BioSig library, this package provides command line
 tools, such as
 .
  - save2gdf: converter between different file formats, including but
        not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF,
        BDF, CWFB.
  - biosig2gdf: converts biosig data files into GDF, to simplify
        parsing and loading by scripting languages (e.g. loadgdf.{py,r})
  - rec2bin, bin2rec, heka2itx, save2aecg, save2scp: several converter
       tools based on save2gdf
  - biosig_fhir: packs biosignal data into HL7/FHIR binary template file.
  - physicalunits: converter for encoding and decoding of physical
       units according to ISO 11073-10101

Package: python3-biosig
Architecture: any
Multi-Arch: same
Section: python
Depends: libbiosig3 (= ${binary:Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Description: Python3 bindings for BioSig library
 This package provides Python3 bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

Package: octave-biosig
Architecture: any
Multi-Arch: same
Depends: libbiosig3 (= ${binary:Version}),
         ${octave:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Octave bindings for BioSig library
 This package provides Octave bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

MAKEOPTS=LIBEXT=so

export PYBUILD_NAME=biosig
export PYBUILD_DIR=biosig4c++/python/

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh  $@ --with python3,numpy3,octave

override_dh_auto_build:
	dh_auto_build -- $(MAKEOPTS) lib tools octave
	pybuild --build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "I: skip testing for now -- relies on download of test data"
endif

override_dh_auto_install:
	dh_auto_install
	pybuild --install

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libcholmod3-dev/libsuitesparse-dev/ \
		    --override s/libtinyxml2.6.2-dev/libtinyxml-dev/ \
		    --movedev debian/tmp/usr/include usr \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so

# No idea whether octave needs the extra LICENSE file - if so it can be deleted here
#override_dh_installdocs:
#	dh_installdocs
#	find debian -name LICENSE -delete

override_dh_auto_clean:
	if [ -f $(PYBUILD_DIR)/setup.py ] ; then pybuild --clean ; fi
	dh_auto_clean

=== debian/watch ===
version=4
https://sf.net/biosig/biosig-(.*)\.src\.tar\.gz
